% *******************************************************
%	IHRS design and optimization using Genetic Algorithms 
%	Check the initial input data.
% *******************************************************
%	26.01.2000 - last : 31.01.00 by OW|BR
%	CheckData.m
% *******************************************************

%	N_ST, N_XT presently not checked ????

%	global fidline
%	global CheckRangeStr
% *******************************************************
% call
%	function ResCheckRange = CheckRange ( param, lower, upper, include_limits )
%	include_limits = 0 :	param = ]lower,upper[
%	include_limits = 1 :	param = ]lower,upper]
%	include_limits = 2 :	param = [lower,upper[
%	include_limits = 3 :	param = [lower,upper]
% *******************************************************

global fidline
global CheckRangeStr

Temp_zeroK = -273.16;
Rmax = 999999;
units = '';

if helppri==1, help CheckData; end
pausetext = 'Press any key ...';
disp('  ');
disp(' Wait for a few seconds ... ! ');

minstr = num2str ( floor((now - floor(now))*100000) );
if rangepri == 1
	CC_R_file = ['CheckConsistency_Ranges_',minstr];
else
	CC_R_file = ['CheckConsistency_Result_',minstr];
end
CC_R_file_m = [CC_R_file, '.m'];
fidline = fopen ( [CC_R_file_m], 'w' );
fullfilename = which ( CC_R_file_m );

PrintAline ( '%*******************************************************' );
PrintAline ( '%	The IHRS project : The EP1 example process	      ' );
PrintAline ( '%	Check the initial input data - The Results.	      ' );
PrintAline ( '%*******************************************************' );
PrintAline ( '%	26.01.2000 - last : ', datestr(now), ' par OW|BR '      );
PrintAline ( '%	CheckConsistency_Ranges_xxxxx.m	 shows all ranges     ' );
PrintAline ( '%	CheckConsistency_Result_xxxxx.m	 shows range errors   ' );
PrintAline ( '%		where xxxxx is generated from hh:mm:ss        ' );
PrintAline ( '%  ' );
PrintAline ( '% ', fullfilename );
PrintAline ( '%  ' );
PrintAline ( '% !!!!!!!!!!!! Listing of datainput errors !!!!!!!!!!   ' );
PrintAline ( '%*******************************************************' );
PrintAline ( ' Start of listing ' );
PrintAline ( '  ' );
%*********************************************************

if checkrange ( I, 1, 20, 3 ),               PrintNum ( I,         ' I         ', units, CheckRangeStr ); end
if checkrange ( J, 1, 20, 3 ),               PrintNum ( J,         ' J         ', units, CheckRangeStr ); end
if checkrange ( K, 2,  8, 3 ),               PrintNum ( K,         ' K         ', units, CheckRangeStr ); end
if checkrange ( M, 1,  1, 3 ),               PrintNum ( M,         ' M         ', units, CheckRangeStr ); end
if checkrange ( N, 1,  1, 3 ),               PrintNum ( N,         ' N         ', units, CheckRangeStr ); end
if checkrange ( O, 1,  1, 3 ),               PrintNum ( O,         ' O         ', units, CheckRangeStr ); end
if checkrange ( P, 2, 30, 3 ),               PrintNum ( P,         ' P         ', units, CheckRangeStr ); end
if checkrange ( I+J+K, 4, 30, 3 ),           PrintNum ( I+J+P,     ' I+J+K     ', units, CheckRangeStr ); end
if checkrange ( t_initial,     0, Rmax, 3 ), PrintNum ( t_initial, ' t_initial ', units, CheckRangeStr ); end
if checkrange ( t_end, t_initial, Rmax, 3 ), PrintNum ( t_end,     ' t_end     ', units, CheckRangeStr ); end
if rangepri == 1, disp( '  ' ); end

for i=1:I				% for Hot streams
	if checkrange ( Stream(i).t_start, t_initial, t_end, 3 ),               PrintNum ( Stream(i).t_start,  ' Stream(',num2str(i),').t_start   ', units, CheckRangeStr ); end
	if checkrange ( Stream(i).t_stop,  t_initial, t_end, 3 ),               PrintNum ( Stream(i).t_stop,   ' Stream(',num2str(i),').t_stop    ', units, CheckRangeStr ); end
	if Stream(i).t_stop > Stream(i).t_start
		if checkrange ( Stream(i).t_stop, Stream(i).t_start, t_end, 3 ),     PrintNum ( Stream(i).t_stop,   ' Stream(',num2str(i),').t_stop    ', units, CheckRangeStr ); end
	else
		if checkrange ( Stream(i).t_stop, t_initial, Stream(i).t_start, 3 ), PrintNum ( Stream(i).t_stop,   ' Stream(',num2str(i),').t_stop    ', units, CheckRangeStr ); end
	end
	if checkrange ( Stream(i).T_S, Temp_zeroK, Rmax, 0 ),             PrintNum ( Stream(i).T_S     , ' Stream(',num2str(i),').T_S       ', units, CheckRangeStr ); end
	if checkrange ( Stream(i).T_T, Temp_zeroK, Stream(i).T_S, 0 ),		PrintNum ( Stream(i).T_T     , ' Stream(',num2str(i),').T_T       ', units, CheckRangeStr ); end
	if checkrange ( Stream(i).CP, 0, Rmax, 0 ),                       PrintNum ( Stream(i).CP      , ' Stream(',num2str(i),').CP        ', units, CheckRangeStr ); end
	if checkrange ( Stream(i).h, 0, Rmax, 0 ),                        PrintNum ( Stream(i).h       , ' Stream(',num2str(i),').h         ', units, CheckRangeStr ); end
	if checkrange ( Stream(i).optional, 0, 1, 3 ),                    PrintNum ( Stream(i).optional, ' Stream(',num2str(i),').optional  ', units, CheckRangeStr ); end
end
for j=1+I:I+J			% for Cold streams
	if checkrange ( Stream(j).t_start, t_initial, t_end, 3 )                PrintNum ( Stream(j).t_start,  ' Stream(',num2str(j),').t_start   ', units, CheckRangeStr ); end
   if checkrange ( Stream(j).t_stop,  t_initial, t_end, 3 ),               PrintNum ( Stream(j).t_stop,   ' Stream(',num2str(j),').t_stop   ', units, CheckRangeStr ); end
	if Stream(j).t_stop > Stream(j).t_start
		if checkrange ( Stream(j).t_stop, Stream(j).t_start, t_end, 3 ),     PrintNum ( Stream(j).t_stop,   ' Stream(',num2str(j),').t_stop   ', units, CheckRangeStr ); end
	else
		if checkrange ( Stream(j).t_stop, t_initial, Stream(j).t_start, 3 ), PrintNum ( Stream(j).t_stop,   ' Stream(',num2str(j),').t_stop   ', units, CheckRangeStr ); end
	end
	if checkrange ( Stream(j).T_S, Temp_zeroK, Rmax, 0 ),                   PrintNum ( Stream(j).T_S,      ' Stream(',num2str(j),').T_S      ', units, CheckRangeStr ); end
	if checkrange ( Stream(j).T_T, Stream(j).T_S, Rmax, 0 ),                PrintNum ( Stream(j).T_T,      ' Stream(',num2str(j),').T_T      ', units, CheckRangeStr ); end
	if checkrange ( Stream(j).CP, -Rmax, 0, 0 ),                            PrintNum ( Stream(j).CP,       ' Stream(',num2str(j),').CP       ', units, CheckRangeStr ); end
	if checkrange ( Stream(j).h, 0, Rmax, 0 ),                              PrintNum ( Stream(j).h,        ' Stream(',num2str(j),').h        ', units, CheckRangeStr ); end
	if checkrange ( Stream(j).optional, 0, 1, 3 ),                          PrintNum ( Stream(j).optional, ' Stream(',num2str(j),').optional ', units, CheckRangeStr ); end
end

if rangepri == 1, disp( '  ' ); end
for m=1:M
	if checkrange ( HotUtility(m).T_in, Temp_zeroK, Rmax, 0 ),                PrintNum ( HotUtility(m).T_in,  ' HotUtility(',num2str(m),').T_in     ', units, CheckRangeStr ); end
	if checkrange ( HotUtility(m).T_out, Temp_zeroK, HotUtility(m).T_in, 0 ), PrintNum ( HotUtility(m).T_out, ' HotUtility(',num2str(m),').T_out    ', units, CheckRangeStr ); end
	if checkrange ( HotUtility(m).h, 0, Rmax, 0 ),                            PrintNum ( HotUtility(m).h,     ' HotUtility(',num2str(m),').h        ', units, CheckRangeStr ); end
end
for n=1:N
	if checkrange ( ColdUtility(n).T_in, Temp_zeroK, Rmax, 0 ),           PrintNum ( ColdUtility(n).T_in,  ' ColdUtility(',num2str(n),').T_in    ', units, CheckRangeStr ); end
	if checkrange ( ColdUtility(n).T_out, ColdUtility(n).T_in, Rmax, 0 ), PrintNum ( ColdUtility(n).T_out, ' ColdUtility(',num2str(n),').T_out   ', units, CheckRangeStr ); end
	if checkrange ( ColdUtility(n).h, 0, Rmax, 0 ),                       PrintNum ( ColdUtility(n).h,     ' ColdUtility(',num2str(n),').h       ', units, CheckRangeStr ); end
end
for o=1:O
	if checkrange ( StorageFluid(o).T_min_SF, Temp_zeroK, Rmax, 0 ),               PrintNum ( StorageFluid(o).T_min_SF, ' StorageFluid(',num2str(o),').T_min_SF',  CheckRangeStr ); end
	if checkrange ( StorageFluid(o).T_max_SF, StorageFluid(o).T_min_SF, Rmax, 0 ), PrintNum ( StorageFluid(o).T_max_SF, ' StorageFluid(',num2str(o),').T_max_SF',  CheckRangeStr ); end
	if checkrange ( StorageFluid(o).rho_SF, 0, Rmax, 0 ),                          PrintNum ( StorageFluid(o).rho_SF,   ' StorageFluid(',num2str(o),').rho_SF  ',  CheckRangeStr ); end
	if checkrange ( StorageFluid(o).cp_SF, 0, Rmax, 0 ),                           PrintNum ( StorageFluid(o).cp_SF,    ' StorageFluid(',num2str(o),').cp_SF   ',  CheckRangeStr ); end
	if checkrange ( StorageFluid(o).h_SF, 0, Rmax, 0 ),                            PrintNum ( StorageFluid(o).h_SF,     ' StorageFluid(',num2str(o),').h_SF    ',  CheckRangeStr ); end
end

if rangepri == 1, disp( '  ' ); end
	if checkrange ( N_XT, 1, Rmax, 3 ), PrintNum ( N_XT, ' N_XT    ', units, CheckRangeStr ); end
	if checkrange ( N_ST, 1, Rmax, 3 ), PrintNum ( N_ST, ' N_ST    ', units, CheckRangeStr ); end
	if checkrange ( Ut_X,     0, 1   , 3 ), PrintNum ( Ut_X,     ' Ut_X        ', units, CheckRangeStr ); end
for n_XT=1:N_XT
	if checkrange ( HEXCostFunction(n_XT).c0_X , 0, Rmax, 2 ), PrintNum ( HEXCostFunction(n_XT).c0_X , ' HEXCostFunction(',num2str(n_XT),').c0_X ', units, CheckRangeStr ); end
	if checkrange ( HEXCostFunction(n_XT).c1_X , 0, Rmax, 0 ), PrintNum ( HEXCostFunction(n_XT).c1_X , ' HEXCostFunction(',num2str(n_XT),').c1_X ', units, CheckRangeStr ); end
	if checkrange ( HEXCostFunction(n_XT).m_X  , 0, 1   , 3 ), PrintNum ( HEXCostFunction(n_XT).m_X  , ' HEXCostFunction(',num2str(n_XT),').m_X  ', units, CheckRangeStr ); end
	if checkrange ( HEXCostFunction(n_XT).A_min, 0, Rmax, 0 ), PrintNum ( HEXCostFunction(n_XT).A_min, ' HEXCostFunction(',num2str(n_XT),').A_min', units, CheckRangeStr ); end
	if checkrange ( HEXCostFunction(n_XT).Un_X , 0, 1   , 3 ), PrintNum ( HEXCostFunction(n_XT).Un_X , ' HEXCostFunction(',num2str(n_XT),').Un_X ', units, CheckRangeStr ); end
end
for n_ST=1:N_ST
	if checkrange ( HSUCostFunction(n_ST).c0_S , 0, Rmax, 2 ), PrintNum ( HSUCostFunction(n_ST).c0_S , ' HSUCostFunction(',num2str(n_ST),').c0_S ', units, CheckRangeStr ); end
	if checkrange ( HSUCostFunction(n_ST).c1_S , 0, Rmax, 0 ), PrintNum ( HSUCostFunction(n_ST).c1_S , ' HSUCostFunction(',num2str(n_ST),').c1_S ', units, CheckRangeStr ); end
	if checkrange ( HSUCostFunction(n_ST).m_S  , 0, 1   , 3 ), PrintNum ( HSUCostFunction(n_ST).m_S  , ' HSUCostFunction(',num2str(n_ST),').m_S  ', units, CheckRangeStr ); end
	if checkrange ( HSUCostFunction(n_ST).V_min, 0, Rmax, 0 ), PrintNum ( HSUCostFunction(n_ST).V_min, ' HSUCostFunction(',num2str(n_ST),').V_min', units, CheckRangeStr ); end
end

if checkrange ( HSULevelParam.I_SL,   0, Rmax, 0 ), PrintNum ( HSULevelParam.I_SL,   ' HSULevelParam(',num2str(n_ST),').I_SL   ', units, CheckRangeStr ); end
if checkrange ( HSULevelParam.G_SL,   0, Rmax, 0 ), PrintNum ( HSULevelParam.G_SL,   ' HSULevelParam(',num2str(n_ST),').G_SL   ', units, CheckRangeStr ); end
if checkrange ( HSULevelParam.p_m_SL, 0,    1, 3 ), PrintNum ( HSULevelParam.p_m_SL, ' HSULevelParam(',num2str(n_ST),').p_m_SL ', units, CheckRangeStr ); end
if checkrange ( HSULevelParam.p_c_SL, 0,    1, 3 ), PrintNum ( HSULevelParam.p_c_SL, ' HSULevelParam(',num2str(n_ST),').p_c_SL ', units, CheckRangeStr ); end
if checkrange ( HSULevelParam.S_SL,   0, Rmax, 0 ), PrintNum ( HSULevelParam.S_SL,   ' HSULevelParam(',num2str(n_ST),').S_SL   ', units, CheckRangeStr ); end
if checkrange ( HEXLevelParam.I_XL,   0, Rmax, 0 ), PrintNum ( HEXLevelParam.I_XL,   ' HEXLevelParam(',num2str(n_XT),').I_XL   ', units, CheckRangeStr ); end
if checkrange ( HEXLevelParam.G_XL,   0, Rmax, 0 ), PrintNum ( HEXLevelParam.G_XL,   ' HEXLevelParam(',num2str(n_XT),').G_XL   ', units, CheckRangeStr ); end
if checkrange ( HEXLevelParam.p_m_XL, 0,    1, 3 ), PrintNum ( HEXLevelParam.p_m_XL, ' HEXLevelParam(',num2str(n_XT),').p_m_XL ', units, CheckRangeStr ); end
if checkrange ( HEXLevelParam.p_c_XL, 0,    1, 3 ), PrintNum ( HEXLevelParam.p_c_XL, ' HEXLevelParam(',num2str(n_XT),').p_c_XL ', units, CheckRangeStr ); end
if checkrange ( HEXLevelParam.S_XL,   0, Rmax, 0 ), PrintNum ( HEXLevelParam.S_XL,   ' HEXLevelParam(',num2str(n_XT),').S_XL   ', units, CheckRangeStr ); end


%*********************************************************
PrintAline ( '  ' );
PrintAline ( ' End of listing ' );
PrintAline ( '%*******************************************************' );
PrintAline ( '%*******************************************************' );
PrintAline ( ' Hidden parameters in InitD.m ' );
PrintAline ( '%*******************************************************' );
checkrange ( interpri, 0, 2, 3 ); PrintNum ( interpri, ' interpri    ', units, CheckRangeStr );
checkrange ( rangepri, 0, 1, 3 ); PrintNum ( rangepri, ' rangepri    ', units, CheckRangeStr );
checkrange ( helppri,  0, 1, 3 ); PrintNum ( helppri,  ' helppri     ', units, CheckRangeStr );
checkrange ( RU,       0, 1, 3 ); PrintNum ( RU,       ' RU          ', units, CheckRangeStr );
PrintAline ( '%*******************************************************' );
fclose ( fidline );
pause(2)
disp ( '  ' );
% help (fullfilename)
type (fullfilename)		% Display the file fullfilename containing data check results
% if rangepri == 0
%	edit (CC_R_file);
% end
%            in WORK directory, if rangepri == 0 : CheckConsistency_Results_xxxxx.m
%            in WORK directory, if rangepri == 1 : CheckConsistency_Ranges_xxxxx.m

disp ( '  ' );
% disp ( ' End of Program --- CheckData !' );
% ***************************************************