% *******************************************************
%	IHRS design and optimization using Genetic Algorithms 
%	GanttData (Time Even Model - Tl and Alp) Program.
% *******************************************************
%	19.01.2000 - last : 03.02.00 by OW|BR
%	GanttData.m
% *******************************************************
%	DataInput should have been run before !
% *******************************************************

if helppri==1, help GanttData; end
pausetext = 'Press any key ...';

disp(' ');
disp ( ' Taking the t_start and t_stop values from Stream data ' ) ;
disp(' ');

Dt = zeros(P);								%	Process duration delta t
Dt_batch = (t_end-t_initial)/60;		%	Total batch duration in hours

t_start_list = [Stream.t_start];
t_stop__list = [Stream.t_stop];
	if interpri > 1
		t_initial
		t_end
		t_start_list
		t_stop__list
	end
[temp,itl] = sort ( [t_initial, t_end, t_start_list,t_stop__list] );
tempsize = length (temp);
i=1;
tlsize = 1;
tl(1) = temp(1);
for i = 1:tempsize-1
	if temp(i+1) > temp(i)
		tlsize = tlsize+1;
		tl(tlsize) = temp(i+1);
	end
end
	if interpri > 0
		disp (' After sorting times and removing identical values : ');
		disp (['tlsize           = ',int2str(tlsize)]);
		disp (['{tl l=1..tlsize} = ',int2str(tl)]);
	end

L = tlsize-1;
activity = zeros ( L, P );

for l=1:L			%	2:tlsize
   Dtl(l) = tl(l+1)-tl(l);
   for p=1:P
      if (Stream(p).t_start <= Stream(p).t_stop)
         if ((Stream(p).t_start <= tl(l)) & (Stream(p).t_stop >= tl(l+1)))
				activity(l,p) = 1;
				Dt(p) = Dt(p) + Dtl(l);
         end
      else
         if ((Stream(p).t_start <= tl(l)) | (Stream(p).t_stop >= tl(l+1)))
				activity(l,p) = 1;
				Dt(p) = Dt(p) + Dtl(l);
         end
      end
   end
end
disp(' ');
disp(' ');
disp ( [ ' Active process Stream matrix (Total duration = ',num2str(Dt_batch,3),' ',duration.units,') ' ] );
disp(' ');
for p=1:P
	disp ( [ ' activity(:,', num2str(p), ')    ', num2str(activity(:,p)',3),...
	'  *  Process duration = ', num2str(Dt(p),3), ' ', time.units , ' or = ', num2str(Dt(p)/60,3), ' ', duration.units  ] );
end
disp(' ');
disp ( [ '  tl         ', num2str(tl,3), '  ', time.units ] );
disp ( [ ' Dtl*60           ', num2str(Dtl,3), '       ', time.units ] );
Dtl = Dtl / 60;
disp ( [ ' Dtl            ', num2str(Dtl,3), '      ', duration.units ] );
disp(' ');
disp ( ' End of Program --- GanttData ! ' );
% ***************************************************