% *******************************************************
%	The IHRS project - The EP1 example process
%	Print a numerical result with the variable name and description in a file.
% *******************************************************
%	31.01.2000 - last : 02.02.00 - OW|BR
%	PrintNum.m
%
%		Maximum 3 string arguments
%	function PrintNum ( paramnum, paramstr[, unitstr[, otherstr]] )
%		paramnum : value numerical parameter
%		paramstr : string containing name  of the numerical parameter
%		unitstr  : string containing units of the numerical parameter
%		otherstr : other string describing
%			PrintNum ( T_Si, 'T_Si', units, CheckRangeStr )
%
%		At least 4 string arguments
%	function PrintNum ( paramnum, paramstrStart, indexstr, paramstrEnd,{unitstr[, otherstr]} )
%		paramnum : value numerical parameter
%		paramstrStart : string containing name  of the numerical parameter
%		indexstr  : string containing units of the numerical parameter
%		paramstrEnd   : string containing name  of the numerical parameter
%		unitstr  : string containing units of the numerical parameter
%		otherstr : other string describing
%			PrintNum ( Stream(i).T_S, ' Stream(',num2str(i),').T_S ', units, CheckRangeStr )
% *******************************************************
% old version : function PrintNum ( paramnum, paramstr, unitstr );

function PrintNum ( varargin );
global fidline

[reg, prop]=parseparams(varargin);
nargs=length(reg);
error(nargchk(1,1,nargs));		% should be 1 : fid if no global fidline
%	fidline = deal (reg {1});
n_string_arg = length(prop);		% at least 1, the string, plus some parameters
%	dispnum ( n_string_arg, 'n_string_arg' )

if     n_string_arg < 1
	disp ( ' PrintNum ( paramnum, paramstr[, unitstr[, otherstr]] ) is the correct syntax !' );
	error('Too few arguments.');
elseif n_string_arg == 1
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ) ];
elseif n_string_arg == 2
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr2 = [ '  ', prop{2}, '  ! ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ), tempstr2 ];
elseif n_string_arg == 3
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr2 = [ '  ', prop{2} ];
	tempstr3 = [ '  ', prop{3}, '  ! ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ), tempstr2, tempstr3 ];
elseif n_string_arg == 4
	tempstr1 = [ ' Value of ', prop{1} ];
	tempstr2 = [ '  ', prop{2} ];
	tempstr3 = [ '  ', prop{3}, ' = ' ];
	tempstr4 = [ '  ', prop{4}, '  ! ' ];
	tempstr = [ tempstr1, tempstr2, tempstr3, num2str( deal (reg {1}) ), tempstr4 ];
elseif n_string_arg == 5
	tempstr1 = [ ' Value of ', prop{1} ];
	tempstr2 = [ '  ', prop{2} ];
	tempstr3 = [ '  ', prop{3}, ' = ' ];
	tempstr4 = [ '  ', prop{4} ];
	tempstr5 = [ '  ', prop{5}, '  ! ' ];
	tempstr = [ tempstr1, tempstr2, tempstr3, num2str( deal (reg {1}) ), tempstr4, tempstr5 ];
else
	disp ( ' PrintNum ( paramnum, paramstr[, unitstr[, otherstr]] ) is the correct syntax !' );
	disp ( ' PrintNum ( paramnum, paramstrStart, indexstr, paramstrEnd,{unitstr[, otherstr]} ) is the correct syntax !' );
	error('Too many arguments.');
end

fprintf ( fidline, '%s\n', tempstr );

% disp ( ' End of Program --- PrintNum !' );
% *******************************************************