%********************************************
%	Function Ave : objective function
%	for EP1 project at LENI
%********************************************
%	01.03.00 - BR
%	22.03.00 - 30.03.00
%	08.01.01 - for optimize v4.40
%********************************************
function [yret1] = Ave (TBCs_min, TBCs_mean, HR_of_TBCs_min, no_gen)
%********************************************
global	ngen
%	global	G_SX		% unuseful ?
global	NGENplot
global 	PrintTrace
%********************************************
%	TBCs_mean		the current mean objective function value TBCs for display purpose
%	TBCs_min		the min  objective function value TBCs
%	HC_of_TBCs_min		the HR value for the min objective function value TBCs
%	Last_but_not_least	Flag = 0 except when done (to plot the best (min) TBCs, with its associated HR)
%	ngen			total number of generation
%	no_gen			the current equivalent number of generations
%	NGENplot		number of generations before refreshing plot
%	NoGEN			

%	dispnum(ngen,'ngen');
if no_gen >= 0
	NoGEN = no_gen;
else
	NoGEN = 0;
end
%	subplot(3,1,2); hold on; hold off;
if PrintTrace > 0
	dispnum ( NoGEN, 'NoGEN', 'out of',num2str(ngen) );
	dispnum ( TBCs_min, 'OF_min' );
	dispnum ( TBCs_mean, 'OF_mean' );
	dispnum ( HR_of_TBCs_min, 'Side_Val_of_OF_min','=====> At end of RAve' );
	disp (' ');
else
	dispnum ( TBCs_min, 'OF_min', ['OF_mean = ', num2str(TBCs_mean), ' ** NoGEN = ', num2str(NoGEN)], ['of ',num2str(ngen),' <=*'] );
end;
	subplot(3,1,2); hold on;
	plot( NoGEN, TBCs_mean, 'k+', NoGEN, TBCs_min, 'b.');
	subplot(3,1,1); hold on;
	if NoGEN == 0,
		plot(HR_of_TBCs_min, TBCs_min, 'rO');
	end;
	if NoGEN == ngen,
		text (8.15,500,['OF_m_i_n = ', num2str(TBCs_min)]);
		plot(HR_of_TBCs_min, TBCs_min, 'b.');
		subplot(3,1,2); hold on;
		plot( NoGEN, TBCs_min, 'r*' );
		drawnow;
	end;

	yret1 = 989;

if ( (floor(NoGEN/NGENplot)*NGENplot) == NoGEN )
	if PrintTrace > 0
		dispnum ( floor(NoGEN/NGENplot),'floor(NoGEN/NGENplot)');
	end;
	drawnow;	% drawnow refreshes the plot (between two drawnow commands, points top plot are stored but wait a drawnow to be displayed)
			% Draw not too often. Might be every gth generations (test NoGEN) !
end;
%********************************************
%	end function Ave
%********************************************
