%********************************************
%	Function OFm : objective function
%	for EP1 project at LENI
%********************************************
%	01.03.00 - BR
%	22.03.00 - etc.
%	08.01.01 - for optimize v4.40
%********************************************
function [yret1,yret2,yret3] = OFm (texte,inX_SX,IV_SX)

%	The number of returned functions yret1 is determined by the number of functions yret(i) defined here.
%	There is no need to specify this number itself, the lone instantiation of the yret(i) is enough.
%********************************************
global 	PrintTrace

nvar = IV_SX;
slope = 1000.0;
Obj_Func = 0.0;
Side_Val = 0.0;
for i = 1:nvar,
	inX_SXi = inX_SX(i);
	if     i == 12
		inX_SXi = inX_SXi -1;	% - 4;
	elseif i == 14
		inX_SXi = inX_SXi +1;	% + 4;
	end

%/////
	Obj_Func = Obj_Func + slope*((inX_SXi-0.8)*(inX_SXi-0.9))^2 + (1/slope)*inX_SXi;	% Theeeeee OF !
%/////

%	solutions (10xXX,1,5,1,-3,1,5xXX)	with int = (1,5,1,-3,1), OF values for slope=0.1 are :
%	XX =      0  0.1000  0.2000  0.3000  0.4000  0.5000  0.6000  0.7000  0.8000  0.8500  0.9000  1.0000
%	OF = 8.2780  5.3560  3.4480  2.3020  1.7020  1.4680  1.4560  1.5580  1.7020  1.7771  1.8520  2.0080
%	solutions (10xXX,1,5,1,-3,1,5xXX)	with int = (1,5,1,-3,1), OF values for slope=0.05 are :
%	XX =      0  0.1000  0.2000  0.3000  0.4000  0.5000  0.6000  0.7000  0.8000  0.8500  0.9000  1.0000
%	OF = 8.2780  5.3560  3.4480  2.3020  1.7020  1.4680  1.4560  1.5580  1.7020  1.7771  1.8520  2.0080

	if PrintTrace > 1
		disp([' i=',num2str(i),' ',num2str(inX_SX(i)),' ',num2str(Obj_Func)]);
	end;
	Side_Val = Side_Val + (1.0/(2.5-inX_SX(i)));
end

subplot(3,1,1);					% axis([0 HR_max TBCs_min TBCs_max]);
hold on; plot(Side_Val, Obj_Func, 'g.');	% plot of improvements stages

Obj_Func_Value = Obj_Func;
Obj_Func_Average = 99999.999;
Obj_Func_HR = Side_Val;
if PrintTrace > 0
	DispNum (Obj_Func_Value, 'Obj_Func_Value');
	DispNum (Obj_Func_Average, 'Obj_Func_Average');
	DispNum (Obj_Func_HR, 'Obj_Func_HR');
end;

yret1(1) = 111;				% c_HEN;
yret1(2) = 222;				% c_STO;
yret1(3) = 333;				% c_UTIL;
yret1(4) = Obj_Func_Value;		% TBCs_best
yret1(5) = Obj_Func_Average;		% TBCs_aver
yret1(6) = Obj_Func_HR;			% TBCs_HR
yret1(7) = 1234567890.1234567890;	% TBCs_other
yret1(8) = 99999.88888;			% TBCs_else

	DvarSize = IV_SX;		% here nvar=IV_SX;	% Number of Dvar elements (array size)
	Dvar = inX_SX;			% Variables in array used in the comparator (distance measurements)
yret2 = Dvar;
yret3 = DvarSize;

%********************************************
%	end function OFm
%********************************************
%	Remove following statement, since drawnow in RAVE.M
%	pause (0.01)			% Pause to give time to the processor to plot the new point !
%********************************************
