%********************************************
%	ed.m
%********************************************
%	Run file for optimize.dll mex file
%********************************************
	global	ngen
	global xx;
	global PrintTrace;
	global	NGENplot
	global TBCs_min
	global HR_of_TBCs_min
    xx = 0;
%********************************************
! move optimize_1.log optimize_1prev.log
diary optimize_1.log

disp (' ');
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp ('  Starting ed.m Matlab procedure for the optimization with Struggle  ');
disp ('          Test edition for optimize v4.42 - L111  (11.01.2001) !     ');
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
help red
disp ( ['          ',datestr(now)] );
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp (' ');

PrintTrace =  0;	% Intermediate printing in Matlab
PTrace     =  0;	% Intermediate printing in Optimize
PnPlot     = -6;	% Plot frequency (refreshes every so and so). If <0, -PnPlot + 1 = total number of refreshes
BCOname = 'Bin';	% 'Int' 'Real' 'Bin' 'List'	% GAXXXBlendCrossover kind for the integer part of Mixedgenome
BCOBmut =  0.01;	% BinBlendCrossover	
			%	When mom & dad get same gene, this probability to get the other binary value
			%	When mom & dad get diff gene, same probability to get the both binary value
BCOIdep = 0.8;		% IntBlendCrossover		% The possible gene value interval is deployed both sides
BCORdep = 0.5;		% RealBlendCrossover		% The possible gene value interval is deployed both sides

nvar = 20;				% nvar = IV_SX;
xopt = 0.9 * ones(1,nvar);
xopt(11:15) = 1;			% P integer variables	
xwei = ones(1,nvar);
xmin =  0.01 * ones(1,nvar);
xmin(11:15) = 0;	% -10;	% 0;	% P integer variables	
xmax =  0.99 * ones(1,nvar);
xmax(11:15) = 1;	% 10;	% 1;	% P integer variables	

xval =  0.5 * ones(1,nvar);
xval(11:15) = 1;	%	P integer variables	

npop = 11;	% 33;	% 22;	% 66;	% 5;
ngen = 22;	% 50;	% 333;	% 33;	% 533;	% 6;
pmut = 0.0;
pcro = 1.0;
nwei = 20;		% length(X) = max(size(X));		% new K523
Dwei = ones(1,nwei);

if     PnPlot > 0
	NGENplot = PnPlot;
elseif PnPlot == 0
	NGENplot = 1;
elseif PnPlot < 0
	NGENplot = floor(-ngen/PnPlot);
end;
if     NGENplot <= 0
	NGENplot = 1;
end;

% structure that defines general user data
UserData.inXsize = nvar;		% 20
UserData.inXopt = xopt;
UserData.inXwei = xwei;
UserData.inXmin = xmin;
UserData.inXmax = xmax;
UserData.inXval = xval;
UserData.inDsize = nwei;		% 20 or more
UserData.inDwei = Dwei

% structure that defines the parameters
Parameters.inN_POP = npop;		% 22
Parameters.inN_GEN = ngen;		% 88
Parameters.inP_MUT = pmut;		% 0.0
Parameters.inP_CRO = pcro;		% 1.0
 Parameters.BCOname = BCOname;		% 'Bin' def='Real'
 Parameters.BCOBmut = BCOBmut;		% 0.01
 Parameters.BCOIdep = BCOIdep;		% 1.0 or 0.5
 Parameters.BCORdep = BCORdep		% 0.5

% structure that defines the control data
 Control.PnPlot = PnPlot;		% 10 or -5
 Control.PTrace = PTrace		% 0 1 2 3

%===========================================================
figure(1)
%	defining the subplots
%	1)the improvements stages
subplot(3,1,1); axis([ 8 14   0 5000]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');
%	2)the evolution of the best individual and the average "individual" as a function of the number of generations
title('Matlab procedure for EP1 project optimization with Struggle at LENI');
text (12.15,4500,'Optimize v4.42 - L111');
subplot(3,1,2); axis([ 0 ngen 0 3000]); grid on; xlabel('Generation [-]'); ylabel('TBCs [CHF/batch]');
%	2)the behaviour of the OF between 0 et 1
subplot(3,1,3); axis([ 0 1 0 1000]); grid on; xlabel('XX'); ylabel('Calculated OF');
pause (0.01);
%===========================================================

% initialisation of output variables
OF_side_size = 99;			% un max
OF_side   = zeros(1,OF_side_size);
OF_side_name1(1,:) = 'cost function     number 1';
OF_side_name1(2,:) = 'cost function     number 2';
OF_side_name1(3,:) = 'cost function     number 3';
OF_side_name1(4,:) = 'best objective function   ';
OF_side_name1(5,:) = 'average objective function';
OF_side_name1(6,:) = 'heat recovery at this OF  ';
OF_side_name1(7,:) = 'new function to be defined';
OF_side_name1(8,:) = 'new function to be defined';
OF_side_name2(1,:) = 'Cost 1        ';
OF_side_name2(2,:) = 'Cost 2        ';
OF_side_name2(3,:) = 'Cost 3        ';
OF_side_name2(4,:) = 'TBCs_min      ';
OF_side_name2(5,:) = 'TBCs_ave      ';
OF_side_name2(6,:) = 'HR_of_TBCs_min';
OF_side_name2(7,:) = 'New_FunFun_1  ';
OF_side_name2(8,:) = 'New_FunFun_2  ';

disp(' ======================================================================== ');
BestGenome.inXsize = nvar;
BestGenome.inXval  = 1000000*ones(nvar,1);
brofflag = 0;
brof
brofflag = 1;
subplot(3,1,3); axis([ 0 1 0 1000]); grid on; xlabel('XX'); ylabel('Calculated OF');
disp(' ======================================================================== ');

tic;
% BestGenome : same structure as UserData
[BestGenome, OF_side, N_OF_side] = optimize ( UserData,Parameters,Control );	% call DLL % new K927
% ========================================================================

disp(' Back after call to optimize.dll. Return to Red.m !!!!! ');
disp(' ');
brof
disp(' ');
dispnum ( N_OF_side,  'Number of side functions  ', '  N_OF_side' );
for i=1:N_OF_side;
	dispnum ( OF_side(i), OF_side_name1(i,:), ['  OF_side(',num2str(i),') = ', OF_side_name2(i,:)] );
end;
disp(' ');
disparray ( BestGenome.inXval, BestGenome.inXsize, 5, 'BestGenome' );
disp(' ');

telapsed=toc;
dispnum ( telapsed, 'time elapsed in Red.m', 'sec' );
disp(' ********************************************************************************************** ');
diary off					%	pour fermer le fichier log
clear optimize					%	pour librer le handle du fichier optimize.dll
save optimize

disp (' Press any key to see more details in 3rd graph');
pause;
subplot(3,1,3); axis([ -0.1 1.1 0.900*OF_side(4) 1.100*OF_side(4)]);

%********************************************
%	end of ed.m
%********************************************

