/* ----------------------------------------------------------------------------
  MLEvalData.h
  BR K316 - K429
  AM K327 - K328

 Definition of a gene. He contains :

  the proper gene as a vector
  Evaluation value
  c_HEN
  c_STO
  c_UTIL
  HR
  TBCs
---------------------------------------------------------------------------- */
#ifndef _ml_eval_h_
#define _ml_eval_h_
#include <ga/GAEvalData.h>
#include <vector>

class MLEvalData	: public GAEvalData
{
public:
				MLEvalData();
				MLEvalData(const MLEvalData&);
	virtual		~MLEvalData();

	virtual		GAEvalData* clone() const;
	virtual void copy(const GAEvalData& aData);
 
	double*		GetGenome();
	void		SetGenome( const int DoubleArraySize, double* DoubleArray );
	double		GetGenomeValue( int index );
	void		SetGenomeValue( int index, double valeur );
	static int	GetNbClone();

private:
	std::vector<double> _TempVec;
	static int	m_NbEval(int);
	static int	NbEval;
};

#endif

